<?php

namespace Litecms\Buses;

use User;

class Buses
{
    /**
     * $buses object.
     */
    protected $buses;

    /**
     * Constructor.
     */
    public function __construct(\Litecms\Buses\Interfaces\BusesRepositoryInterface $buses)
    {
        $this->buses = $buses;
    }

    /**
     * Returns count of buses.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.buses.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->buses->pushCriteria(new \Litepie\Litecms\Repositories\Criteria\BusesUserCriteria());
        }

        $buses = $this->buses->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('buses::' . $view, compact('buses'))->render();
    }
}
